Subject: bug#42147: 28.0.50; pure vs side-effect-free, missing optimizations?

From: Stefan Monnier <[email-masked]>
Date: Mon, 10 Aug 2020 18:10:39 -0400

> Arguments relating to probabilities ("most users", "vast majority",
> "rare") don't really apply here, as the discussion is about
> correctness. A pure function must be pure 100% of the time, no
> exceptions allowed. `package-get-version' can't possibly be pure: it
> doesn't take any argument, so if it were pure, it would have to return
> a constant in the mathematical sense.

It's a borderline case: it's designed such that if the compiler
pre-evaluates it, the result will indeed be the same as if it were
evaluated later at run-time.

So it's correct w.r.t "allow constant-folding", even tho it's not
"pure".

        Stefan